<?php

namespace Argus\Discord;

use DateTime;
use Exception;


class Announcement {

    static string $woocommerceOrderSlug = 'shop_order';


    static function announceCPT ($newStatus, $oldStatus, $post) {

        if (wp_is_post_revision($post->ID)) return;
        if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) return;

        $cpt = explode(',', get_option('argusDiscordAnnouncementCPT'));
        if (!count($cpt)) return;

        if ($cpt != self::$woocommerceOrderSlug && in_array($post->post_type, $cpt)) {
            if (($newStatus == 'publish' && $oldStatus != 'publish') || ($newStatus == 'publish' && $oldStatus == 'publish' && (!get_option('argusDiscordLastAnnouncementTimestamp') || get_option('argusDiscordLastAnnouncementTimestamp') < strtotime("-1 minutes")) && get_option('dwpp-announcement-updates'))) {
                update_option('argusDiscordLastAnnouncementTimestamp', time());
                self::send($post);
            }
        }

    }


    static function send ($post) {
        $message = '';

        if ($post->post_title) $message .= '**' . $post->post_title . '**';

        if (get_option('argusDiscordAnnouncementAddDate')) {
            if ($post->post_type == 'mec-events') {
                $mecStartDate = get_post_meta($post->ID, 'mec_start_date', true);
                if ($mecStartDate) {
                    try {
                        $startDate = (new DateTime($mecStartDate))->format(get_option('date_format'));
                    } catch (Exception $e) {
                        $startDate = $e->getMessage();
                    }
                    $message .= "\n" . $startDate;
                }
            } elseif ($post->post_type == 'tribe_events') {
                if (function_exists('tribe_get_start_date')) {
                    $startDate = tribe_get_start_date($post->ID);
                    if ($startDate) $message .= "\n" . $startDate;
                }
            }
        }

        if ($post->post_excerpt && get_option('argusDiscordAnnouncementAddExcerpt')) $message .= "\n" . $post->post_excerpt;

        $message .= "\n" . get_permalink($post->ID);

        if (get_option('argusDiscordAnnouncementAddEveryone')) $message .= "\n@everyone";

        Data::sendMessage(wp_strip_all_tags($message));
    }


    static function announceWoocommerceOrder ($order_id) {
        $cpt = explode(',', get_option('argusDiscordAnnouncementCPT'));
        if (in_array(self::$woocommerceOrderSlug, $cpt)) {

            $message = '**' . __("New Order", 'argus-wordpress-plugin') . '**';
            $message .= "\n" . get_admin_url(null, 'post.php?post=' . $order_id . '&action=edit');
            Data::sendMessage(wp_strip_all_tags($message));
        }
    }

}
