<?php

namespace Argus\Discord;

if (!defined('ABSPATH')) exit;


add_action('enqueue_block_editor_assets', function() {
    wp_enqueue_style('argus-frontend-styles', ARGUS_DISCORD_PLUGIN_URL . 'views/styles/frontend.css', [], ARGUS_PLUGIN_VERSION);
});


add_action('init', function() {

    Gutenberg::init('authorization');

    register_block_type('argus-wordpress-plugin/argus-discord-authorization-gutenberg-block', [
        'editor_script'   => 'argus-discord-authorization-gutenberg-block',
        'render_callback' => function($instance) {
            if (is_user_logged_in()) {
                $text = $instance['logoutText'] ?? __("Logout", 'argus-wordpress-plugin');
            } else {
                $text = $instance['loginText'] ?? __("Login with Discord", 'argus-wordpress-plugin');
            }
            $instance['className']  = $instance['className'] ?? '';
            $instance['styling']    = $instance['styling'] ?? 'no';
            $instance['redirectTo'] = $instance['redirectTo'] ?? 'argus-auth-discord-go-last-page';
            $instance['className']  .= 'argus__button--' . $instance['styling'] . '-style';

            if (is_user_logged_in()) {
                $link = wp_logout_url($_SERVER['REQUEST_URI']);
            } else {
                $link = Data::getAuthorizationLink($instance['redirectTo']);
            }

            if ($instance['styling'] != 'no') wp_enqueue_style('argus-discord-front-end-styles');

            return '<a class="argus__authorization ' . $instance['className'] . '" href="' . $link . '">' . $text . '</a>';
        },
    ]);
});
