<?php

namespace Argus\Discord;

if (!defined('ABSPATH')) exit;


// Registering template
add_action('wp_dashboard_setup', function() {
    wp_add_dashboard_widget('argus_status', __("Discord Synchronization Status", 'argus-wordpress-plugin'), function($post, $callback_args) {

        $lastError = get_option('argusDiscordErrorMessage');

        $connectionCheck = true;
        if (!Data::fetchAuthorizedProfile()) {
            $connectionCheck = false;
            $connectionText  = __("General access not valid.", 'argus-wordpress-plugin') . ' ';
            $connectionText  .= get_option('argusDiscordErrorMessage');
        } else {
            $connectionText = __("Profile data updated, general access valid", 'argus-wordpress-plugin');
        }

        wp_enqueue_script('argus-admin-helpers-scripts');
        include_once ARGUS_DISCORD_PLUGIN_PATH . 'widgets/status/status.phtml';
    });
});


// Adding help tabs
add_action('admin_head', function() {
    global $pagenow;
    if ($pagenow == 'index.php') {
        $currentScreen = get_current_screen();
        include_once ARGUS_DISCORD_PLUGIN_PATH . 'views/includes/errors-help.php';
        foreach ($errorsHelp as $tab) {
            $currentScreen->add_help_tab($tab);
        }
    }
});


// Registering widget scripts
add_action('admin_enqueue_scripts', function($hook_suffix) {
    if ($hook_suffix == 'index.php') {
        wp_enqueue_media();
        wp_enqueue_script('argus-status', ARGUS_DISCORD_PLUGIN_URL . 'widgets/status/status.js', ['jquery'], ARGUS_PLUGIN_VERSION, true);
        wp_enqueue_style('argus-status', ARGUS_DISCORD_PLUGIN_URL . 'widgets/status/status.css', [], ARGUS_PLUGIN_VERSION);
    }
});
