<?php

namespace Argus\Steam;

use Elementor\Plugin;

final class Elementor {

    private static ?Elementor $_instance = null;


    public static function instance ():?Elementor {
        if (is_null(self::$_instance)) self::$_instance = new self();
        return self::$_instance;
    }


    function __construct () {
        add_action('elementor/widgets/register', ['Argus\Steam\Elementor', 'register_widgets'], 99);
        add_action('elementor/frontend/after_enqueue_styles', ['Argus\Steam\Elementor', 'widget_styles']);
    }


    static function register_widgets () {
        include_once ARGUS_STEAM_PLUGIN_PATH . 'widgets/authorization/ElementorWidgetAuthorization.php';

        Plugin::instance()->widgets_manager->register(new ElementorWidgetAuthorization());
    }


    static function widget_styles () {
        wp_enqueue_style('argus-steam-front-end-styles');
    }


    static function register_category () {
        add_action('elementor/elements/categories_registered', function($elementsManager) {
            $elementsManager->add_category('argus-steam-category', [
                'title' => __("Steam", 'argus-wordpress-plugin'),
                'icon'  => 'fab fa-discord',
            ]);
        });
    }


    static function connect_editor_assets () {
        wp_enqueue_style('argus-steam-elementor-icons', ARGUS_STEAM_PLUGIN_URL . 'views/styles/elementor-icons.css', [], ARGUS_PLUGIN_VERSION);
    }

}
