<?php

namespace Argus\Steam;

if (!defined('ABSPATH')) exit;


add_shortcode('argus-steam-authorization-button', function($attributes, $content) {

    if (!$attributes || !is_array($attributes)) $attributes = [];

    if (!isset($attributes['redirect']) || ($attributes['redirect'] != 'prev' && $attributes['redirect'] != 'last')) {
        $attributes['redirect'] = 'last';
    }

    if (!$content) {
        if (is_user_logged_in()) {
            $content = __("Logout", 'argus-wordpress-plugin');
        } else {
            $content = __("Login with Steam", 'argus-wordpress-plugin');
        }
    }

    if (is_user_logged_in()) {
        $link = wp_logout_url($_SERVER['REQUEST_URI']);
    } else {
        $link = Data::getAuthorizationLink('argus-auth-steam-go-' . $attributes['redirect'] . '-page');
    }

    if (isset($attributes['style'])) {
        wp_enqueue_style('argus-discord-front-end-styles');
        $class = 'argus-steam__button--' . $attributes['style'] . '-style';
    } else {
        $class = 'argus-steam__button--no-style';
    }

    return '<a class="argus-steam__authorization ' . $class . '" href="' . $link . '">' . $content . '</a>';
});
