<?php

namespace Argus;

class Cron {


    static function init () {
        add_action('argus_clean_logs', function() {
            Log::cleanLogs(true);
        });
        add_action('argus_check_update', function() {
            Data::getLastUpdateInfo();
        });
    }


    static function schedule () {
        $cronEvents = [
            ['argus_clean_logs', time() + DAY_IN_SECONDS, 'daily'],
            ['argus_check_update', time() + DAY_IN_SECONDS, 'daily'],
        ];

        foreach ($cronEvents as $event) {
            if (!wp_next_scheduled($event[0])) {
                wp_schedule_event($event[1], $event[2], $event[0]);
            }
        }
    }


    static function unschedule () {
        $cronEventsHooks = [
            'argus_clean_logs',
            'argus_check_update',
        ];

        foreach ($cronEventsHooks as $hook) wp_clear_scheduled_hook($hook);
    }

}
