<?php

namespace Argus;

class Uninstall {

    protected static array $pluginDBTables = [
        'argus_log',
    ];

    protected static array $discordDBTables = [
        'argus_discord_messages',
        'argus_discord_assigned_roles',
        'argus_discord_bound_roles',
        'argus_discord_members',
        'argus_discord_collected_data',
        'argus_discord_channels',
        'argus_discord_roles',
    ];


    static function uninstall () {

        // General Argus Data
        self::removePluginDBTables(self::$pluginDBTables);

        $optionTableVariables = [
            'argusDomainAuthentication',
            'argusActivateTranslations',
            'argusPurchaseCode',
            'argusLastUpdateOnServer',
            'argusLastUpdateOnVersion',
            'argusSupportExpireDate',
            'argusSupportExpireDateLastUpdate',
            'argusActiveComponents',
        ];

        foreach ($optionTableVariables as $option) delete_option($option);


        // Discord Component Data
        self::removePluginDBTables(self::$discordDBTables);

        $optionTableVariables = [
            'argusDiscordOAuth2ClientID',
            'argusDiscordOAuth2ClientSecret',
            'argusDiscordOAuth2BotToken',
            'argusDiscordOAuth2TokenResponse',
            'argusDiscordOAuth2AccessToken',
            'argusDiscordOAuth2State',
            'argusDiscordWebhook',
            'argusDiscordGuild',
            'argusDiscordErrorMessage',
            'argusDiscordDataProfile',
            'argusDiscordDataApp',
            'argusDiscordDataGuild',
            'argusDiscordAnnouncementCPT',
            'argusDiscordAnnouncementAddEveryone',
            'argusDiscordAnnouncementAddExcerpt',
            'argusDiscordAnnouncementAddDate',
            'argusDiscordAnnouncementUpdates',
            'argusDiscordLastAnnouncementTimestamp',
            'argusDiscordCommentsCPT',
            'argusDiscordStylingOAuthButtons',
            'argusDiscordModifyWPLoginForm',
            'argusDiscordModifyMemberPressLoginForm',
            'argusDiscordDeleteFromGuildIfProfileDisconnected',
            'argusDiscordGuildFilterMode',
            'argusDiscordGuildFilter',
            'argusDiscordRolesFilterMode',
            'argusDiscordRolesFilter',
            'argusDiscordFilterProfileConnection',
            'argusDiscordBlockNotVerified',
            'argusDiscordBlockPending',
            'argusDiscordNewUserRedirect',
            'argusDiscordNewUserRedirectInNewTab',
            'argusDiscordNewUserRedirectIfNotInGuild',
            'argusDiscordProfileConnectedRedirect',
            'argusDiscordCustomRedirects',
            'argusDiscordWoocommerceAccountPage',
            'argusDiscordAssignRoleIfProfileConnected',
            'argusDiscordUltimateMemberAccountPage',
            'argusDiscordUltimateMemberAccountPageIcon',
            'argusDiscordMemberPressAccountPage',
            'argusDiscordBuddypressAccountPage',
            'argusDiscordReplaceWPAvatars',
            'argusDiscordReplaceBuddypressAvatars',
            'argusDiscordReplaceDefaultAvatar',
        ];

        foreach ($optionTableVariables as $option) delete_option($option);


        // Steam Component Data
        $optionTableVariables = [
            'argusSteamCommentsCPT',
            'argusSteamStylingOAuthButtons',
            'argusSteamModifyWPLoginForm',
            'argusSteamCustomRedirects',
        ];

        foreach ($optionTableVariables as $option) delete_option($option);
    }


    protected static function removePluginDBTables ($pluginDBTables) {
        global $wpdb;

        $wpdb->query('SET FOREIGN_KEY_CHECKS = 0;');
        foreach ($pluginDBTables as $table) {
            $wpdb->query('DROP TABLE IF EXISTS `' . $wpdb->prefix . $table . '`;');
        }
        $wpdb->query('SET FOREIGN_KEY_CHECKS = 1;');
    }

}
